/*-------------------------------------+-------------------------------------*/
/*                                  board.h                                  */

#ifndef BOARDHEADER
#define BOARDHEADER

#undef NULL

#define NULL 0
enum boolean {FALSE, TRUE};

enum player  {WHITE, BLACK};
enum object  {PAWN, KNIGHT, BISHOP, ROOK, QUEEN, KING};


struct field;

struct piece {
   player dark;
   object type;
   field * loc;
};

struct field {
   piece * occ;
   field * pnext[2][2];
   field * xnext[2][2];
   field * Nnext[8];
   field * Bnext[4];
   field * Rnext[4];
   field * QKnext[8];
};

struct state {
   boolean OOwhite  : 1;
   boolean OOOwhite : 1;
   boolean OOblack  : 1;
   boolean OOOblack : 1;
   field * epfield;
};


extern piece piecelist[2][16];
extern field board[64];
extern state specials;
extern player color;

boolean attacked (field *);

#endif

